import java.awt.Choice;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.util.Enumeration;

import javax.comm.CommPortIdentifier;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public class Bootloader_GUI extends JFrame implements ActionListener{
	
	//Visuelle Komponenten
	Container c;
	
	JScrollPane historyScrollPane;
	
	JTextArea history;
	
	JButton btnOpenFlashFile;
	JButton btnOpenEepromFile;
	JButton btnFlash;
	JButton btnRead;
	JButton btnAbort;
	
	JCheckBox chkVertify;
	
	JLabel lblFlashFile;
	JLabel lblEepromFile;
	JLabel lblBaudrate;
	JLabel lblVertify;
	JLabel lblComPort;
	
	JTextField txtFlashFile;
	JTextField txtEepromFile;
	
	Choice baudrateChoice;
	Choice comPortChoice;
	
	JProgressBar flashProgressBar;
	
	JFileChooser fileChooser;
	
	// Variablen
	
	Bootloader bootloader;
	
	public Bootloader_GUI(Bootloader bootloader){
		super("Bootloader Flash Utility");
		this.setSize(400,300);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setLocationByPlatform(true);
		
		this.bootloader = bootloader;
				
		c = getContentPane();
		c.setLayout(null);
		
		history = new JTextArea();
		history.setAutoscrolls(true);
		history.setEditable(false);
		
		historyScrollPane = new JScrollPane();
		historyScrollPane.setBounds(0,170,this.getWidth()-7,85);
		historyScrollPane.setViewportView(history);
		
		lblBaudrate = new JLabel("Baudrate:");
		lblBaudrate.setBounds(0,0,100,20);
		lblComPort = new JLabel("Comport:");
		lblComPort.setBounds(200,0,100,20);
		lblVertify = new JLabel("Vertify:");
		lblVertify.setBounds(0,20,100,20);
		lblFlashFile = new JLabel("Flash File:");
		lblFlashFile.setBounds(0,40,100,20);
		lblEepromFile = new JLabel("EEProm FIle:");
		lblEepromFile.setBounds(0,60,100,20);
		
		chkVertify = new JCheckBox("",false);
		chkVertify.setBounds(100,20,20,20);
		
		txtFlashFile = new JTextField();
		//txtFlashFile.setEnabled(false);
		txtFlashFile.setBounds(100,40,200,20);
		txtEepromFile = new JTextField();
		//txtEepromFile.setEnabled(false);
		txtEepromFile.setBounds(100,60,200,20);
		
		baudrateChoice = new Choice();
		baudrateChoice.setBounds(100,0,70,20);
		baudrateChoice.add("1200");
		baudrateChoice.add("2400");
		baudrateChoice.add("4800");
		baudrateChoice.add("9600");
		baudrateChoice.add("14400");
		baudrateChoice.add("19200");
		baudrateChoice.add("28800");
		baudrateChoice.add("38400");
		baudrateChoice.add("56000");
		baudrateChoice.add("57600");
		baudrateChoice.add("115200");
		baudrateChoice.select("115200");
		comPortChoice = new Choice();
		comPortChoice.setBounds(300,0,70,20);
		Enumeration commports = CommPortIdentifier.getPortIdentifiers();
		while (commports.hasMoreElements()) {
			CommPortIdentifier element = (CommPortIdentifier)commports.nextElement();
			if (element.getPortType() == CommPortIdentifier.PORT_SERIAL) {
				comPortChoice.add(element.getName());
			}
		}
		
		btnOpenFlashFile = new JButton("Open");
		btnOpenFlashFile.setBounds(300,40,100,20);
		btnOpenFlashFile.addActionListener(this);
		btnOpenEepromFile = new JButton("Open");
		btnOpenEepromFile.addActionListener(this);
		btnOpenEepromFile.setBounds(300,60,100,20);
		btnFlash = new JButton("Flash");
		btnFlash.addActionListener(this);
		btnFlash.setBounds(100,90,100,30);
		btnRead = new JButton("Read");
		btnRead.addActionListener(this);
		btnRead.setBounds(100,130,100,30);
		btnAbort = new JButton("Abort");
		btnAbort.setBounds(220,90,100,30);
		btnAbort.addActionListener(this);
		
		flashProgressBar = new JProgressBar(0,100);
		flashProgressBar.setBounds(0,this.getHeight()-45,392,10);
		
		c.add(lblFlashFile);
		c.add(lblEepromFile);
		c.add(lblBaudrate);
		c.add(lblComPort);
		c.add(lblVertify);
		c.add(chkVertify);
		c.add(txtFlashFile);
		c.add(txtEepromFile);
		c.add(baudrateChoice);
		c.add(comPortChoice);
		c.add(btnOpenFlashFile);
		c.add(btnOpenEepromFile);
		c.add(btnFlash);
		c.add(btnRead);
		c.add(btnAbort);
		c.add(flashProgressBar);
		c.add(historyScrollPane);

	}

	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		if (source == btnOpenFlashFile) {
			fileChooser = new JFileChooser();
			fileChooser.setMultiSelectionEnabled(false);
			fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
			if (fileChooser.showOpenDialog(this)!=JFileChooser.APPROVE_OPTION) {
				return;
			}
			txtFlashFile.setText(fileChooser.getSelectedFile().toString());
		}else if(source == btnOpenEepromFile){
			fileChooser = new JFileChooser();
			fileChooser.setMultiSelectionEnabled(false);
			fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
			if (fileChooser.showOpenDialog(this)!=JFileChooser.APPROVE_OPTION) {
				return;
			}
			txtEepromFile.setText(fileChooser.getSelectedFile().toString());
		}else if(source == btnFlash){
			
			bootloader.setBaudrate(Integer.parseInt(baudrateChoice.getSelectedItem()));
			bootloader.setComport(comPortChoice.getSelectedItem());
			
			btnFlash.setEnabled(false);
			Thread thread = new bootloaderFlashThread();
			thread.start();
		}else if(source == btnAbort){
			bootloader.interrupt();
			btnFlash.setEnabled(true);
		}/*else if(source == btnRead){
			int[] fa = new int[1], la = new int[1];
			char[] data = new char[65536];
			try {
				bootloader.readhex(new File(txtFlashFile.getText()),data,fa,la);
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			for (int i = fa[0]; i < la[0]; i++) {
				System.out.println((int)data[i]);
			}
		}*/
	}
	
	class bootloaderFlashThread extends Thread{
		public void run(){
			long start = 0;
			try {
				int returncode;
				String flashFileName = txtFlashFile.getText();
				String eepromFileName = txtEepromFile.getText();
				history.append("Port: "+comPortChoice.getSelectedItem()+" Baudrate: "+baudrateChoice.getSelectedItem()+" ... ");
				if (bootloader.connect()) {
					history.append("Connected! \n");
				}else{
					history.append("Aborted! \n\n");
					return;
				}
				start = System.currentTimeMillis();
				history.append("Signature: "+bootloader.read_sig()+ "\n");
				if (new File(flashFileName).exists()) {
					if (chkVertify.isSelected()) {
						history.append("Vertifying Flash ... ");
					}else{
						history.append("Programming Flash ... ");
					}
					
					returncode = bootloader.program(new File(flashFileName),chkVertify.isSelected(),false,flashProgressBar);
					if (returncode == -1) {
						history.append("Unerwartetes Dateiende - Datei defekt\n");
					}else if(returncode == -2){
						history.append("Keine Hex-Datei oder Datei defekt\n");
					}else if(returncode == -3){
						history.append("Keine Antwort\n");
					}else if(returncode == -4){
						history.append("Fehler bei Adresse: "+bootloader.errAddr+"\n");
					}else if(returncode == 0){
						if (bootloader.read_crc() == 0) {
							history.append("Done! \nCRC Pass\n");
						}else{
							history.append("CRC error\nFailed!\n");
						}
					}
				}
				if(new File(eepromFileName).exists()){
					history.append("Programming EEProm ... ");
					returncode = bootloader.program(new File(eepromFileName),false,true,flashProgressBar);
					if (returncode == -1) {
						history.append("Unerwartetes Dateiende - Datei defekt\n");
					}else if(returncode == -2){
						history.append("Keine Hex-Datei oder Datei defekt\n");
					}else if(returncode == -3){
						history.append("Keine Antwort\n");
					}else if(returncode == -4){
						history.append("Fehler bei Adresse: "+bootloader.errAddr+"\n");
					}else if(returncode == 0){
						if (bootloader.read_crc() == 0) {
							history.append("Done!\nCRC Pass\n");
						}else{
							history.append("CRC error\nFailed!\n");
						}
					}
				}
				if( !(new File(flashFileName).exists()) && !(new File(eepromFileName).exists())){
					history.append("No input file Selected!\n");
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
			try {
				bootloader.disconnect();
			} catch (IOException e) {
			}
			long end = System.currentTimeMillis();
			history.append("Finished programming in "+(end-start)/1000.0+"s");
			history.append("\n");
			btnFlash.setEnabled(true);
		}
	}
}
