import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.geom.Rectangle2D;

import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.JLabel;

public class UniversalDialog extends JDialog {

	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private String message;

	/**
	 * This is the default constructor
	 */
	public UniversalDialog(String title, String message) {
		super();
		this.message = message;
		initialize(title);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize(String title) {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle(title);
		this.setModal(true);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel = new JLabel();
			jLabel.setText(message);
			Font font = jLabel.getFont();
			FontMetrics fm = jLabel.getFontMetrics(font);
			Rectangle2D stringRect = fm.getStringBounds(message,jLabel.getGraphics());
			jLabel.setSize((int)stringRect.getWidth(),(int)stringRect.getHeight());
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(jLabel, java.awt.BorderLayout.CENTER);
			jContentPane.setSize(new Dimension(jLabel.getWidth(),jLabel.getHeight()));
			jContentPane.setPreferredSize(new Dimension(jLabel.getWidth(),jLabel.getHeight()));
			this.setSize(new Dimension(jLabel.getWidth()+50,jLabel.getHeight()+50));
			this.setPreferredSize(new Dimension(jLabel.getWidth()+50,jLabel.getHeight()+20));		
		}
		return jContentPane;
	}

}
